﻿#20130610
bl_info = {
    "name": "uv_tool",
    "author": "imdjs",
    "version": (1,6,2),
    "blender": (2, 7, 0),
    "api": 270,
    "location": "IMAGE_EDITOR > UI ",
    "description": "smooth selected uv line",
    "warning": "",
    "wiki_url": "http://blog.sina.com.cn/u/1325600780",
    "tracker_url": "http://blog.sina.com.cn/s/blog_4f03100c01010wqb.html",
    "category": "UV"}

import os,ctypes
import bpy, math,  mathutils,bmesh
from ctypes import *
from bpy.props import *
from math import *
from mathutils import Vector

dir = os.path.dirname(__file__)
##print(dir)
dllpath32E = os.path.abspath("%s//c++function32.dll" % dir)
dllpath64E = os.path.abspath("%s//c++function64.dll" % dir)
dllpath32B ="B://c++function32.dll" 
dllpath64B ="B://c++function64.dll" 
#used_path = None

b闭=False ;
class 卐DLL类型():
    def __init__(self):
        wm = bpy.context.window_manager;
        self.DLL=None;
    i左右不同点=0;i右点找不到左点数=0;b已经弹出窗口=False ;

D=卐DLL类型();

D.DLL=None

try:
    D.DLL = CDLL(dllpath32E);
except:
    D.DLL = CDLL(dllpath64E);
    #D.D.DLL = CDLL(dllpath64B)
                                                                           

##print ("DLL是-----------------",D.DLL)
def cf2ΔΔ转uv为cf2(uv):
    return (c_float*2)(uv[0],uv[1]);
 
def Lcf3ΔΔ得选点网co列表(ii选点总数,L顺层LLi同位置环_i组_i点索序):
    #ii选点总数=len(L顺层LLi同位置环_i组_i点索序[0]);
    Lcf3网点Co序=((c_float*3)*ii选点总数)();
    id= bpy.context.active_object.data ; #:type: id  
    Lmuvl = id.uv_layers.active.data ;
    Lmv=id.vertices;

    for i序 in range( ii选点总数):
        ##print("PointIndex==",L顺层LLi同位置环_i组_i点索序[0][i序]);
        mv=Lmv[L顺层LLi同位置环_i组_i点索序[0][i序][2]];
        Lcf3网点Co序[i序]=(c_float*3)( mv.co.x, mv.co.y, mv.co.z );

    return  Lcf3网点Co序;

  
#———————————————————————————————————————————————————————
def ΔΔ找到连贯线选(id,Lmuvl,L顺层LLi同位置环_i组_i点索序,Li所有三角面组,Di组此Li组左右选,Di全部环i组,Di全部环i点索,Di全部组LLi面索_Li环) :
    #---把相同位置环加入组--------------------------------------------------------------
    i组数=0;Li已入组的环=[];LLi环f2UV全部=[];LLi环f2UV全部比较=[];
    global b三角面G;
    #---查找Di全部环i组 ----------------------------------------
    #先找出四个共面的组，然后再把少于四个共面的组根据uv分组
    Di全部点索Li环={};
    #---检测第一组有无三角面--------------------------------------------------------------------
    if(not bpy.context.window_manager.bp传播wm):
        for i面索,mp全部 in enumerate(id.polygons):
            b线选=False;i边数=len(mp全部.loop_indices);
            for i步3 in range(i边数): #如果是四边面 len等于4 如果是三角面len等于3，
                i步3下步 = (i步3+1) % i边数;
                i点索 = mp全部.vertices[i步3];#Vertex indices 如果是四边面 len等于4 如果是三角面len等于3
                i点索下 = mp全部.vertices[i步3下步];
                i环=mp全部.loop_indices[i步3];
                i环下=mp全部.loop_indices[i步3下步];

                b选muvl一 = False;b选muvl二=False ;
                b选muvl一= Lmuvl[mp全部.loop_indices[i步3]].select; #mp全部.loop_indices[i步3] 为MeshUVLoop的索引         
                b选muvl二= Lmuvl[mp全部.loop_indices[i步3下步]].select;      
                if (b选muvl一 and b选muvl二):# 如果一条线两点被选中
                    if(not b三角面G and i边数==3):
                        b三角面G=True;print("TRIANGLE",);
                        break;
    #----------------------------------------------------------------------------
    for i面索,mp全部 in enumerate(id.polygons):
        b线选=False;i边数=len(mp全部.loop_indices);
        for i步3 in range(i边数): #如果是四边面 len等于4 如果是三角面len等于3，
            i步3下步 = (i步3+1) % i边数;
            i点索 = mp全部.vertices[i步3];#Vertex indices 如果是四边面 len等于4 如果是三角面len等于3
            i点索下 = mp全部.vertices[i步3下步];
            i环=mp全部.loop_indices[i步3];
            i环下=mp全部.loop_indices[i步3下步];

            b选muvl一 = False;b选muvl二=False ;
            b选muvl一= Lmuvl[i环].select; #mp全部.loop_indices[i步3] 为MeshUVLoop的索引         
            b选muvl二= Lmuvl[i环下].select;
                
            if(bpy.context.window_manager.bp传播wm or b三角面G==True):
                if(i点索 not in Di全部点索Li环):  
                    Di全部点索Li环[i点索]=[];         
                if(i环 not in Di全部点索Li环[i点索]):
                    Di全部点索Li环[i点索].append(i环);#{i组:[i环,i环]}               
            elif(not bpy.context.window_manager.bp传播wm ):
                if (b选muvl一):# 如果有一点被选中
                    if(i点索 not in Di全部点索Li环):  
                        Di全部点索Li环[i点索]=[];         
                    if(i环 not in Di全部点索Li环[i点索]):
                        Di全部点索Li环[i点索].append(i环);#{i组:[i环,i环]}
                        
                """
                if (b选muvl一 and b选muvl二):# 如果一条线两点被选中
                    if(i点索 not in Di全部点索Li环):  
                        Di全部点索Li环[i点索]=[];         
                    if(i环 not in Di全部点索Li环[i点索]):
                        Di全部点索Li环[i点索].append(i环);#{i组:[i环,i环]}
                        
                    if(i点索下 not in Di全部点索Li环):  
                        Di全部点索Li环[i点索下]=[];         
                    if(i环下 not in Di全部点索Li环[i点索下]):
                        Di全部点索Li环[i点索下].append(i环下);#{i组:[i环,i环]}
                """

            #----------------------------------------------------------------------------
            if(i环 not in Di全部环i点索):
                Di全部环i点索[i环]=i点索;
    #print("D All IP,R",Di全部点索Li环);

    #---根据uv位置分组-----------------------------------------------------------------
    
    for  i点索,Li环 in  Di全部点索Li环.items():
        LLi相同UV环=[];i同点不同uv组数=0;Li点内已经比较环=[];
        for i比较步,i比较环 in  enumerate(Li环):#迭代一个点内的多个环
            if(i比较环 in Li点内已经比较环):#如果已经找到与比较环相等的环，就不用再新建比较环
                continue;
            uv比较环=Lmuvl[i比较环].uv;LLi相同UV环.append([]);#新几个表示共有几组环 不相等
            LLi相同UV环[i同点不同uv组数].append(i比较环);
            Li点内已经比较环.append(i比较环);
            for i步,i环 in  enumerate(Li环):#迭代一个点内的多个环
                if(i比较步!=i步 and uv比较环==Lmuvl[i环].uv and i环 not in Li点内已经比较环):#找到一个与比较环相等的环
                    LLi相同UV环[i同点不同uv组数].append(i环);#[[i环,i环],[i环,i环]]
                    Li点内已经比较环.append(i环);
            i同点不同uv组数+=1;
        
        if(len(LLi相同UV环)<2 ):#如果此点带四个环
            for i步,i环 in  enumerate(Li环):
                Di全部环i组[i环]=i组数;
            i组数+=1;#增加一个组
            
        else:#有多个不同uv的环
            for i组,Li相同UV环 in  enumerate(LLi相同UV环):
                for i相同UV环 in  Li相同UV环:
                    Di全部环i组[i相同UV环]=i组数;
                i组数+=1;#增加一个组
                
        
    #print("D All  R:G==",Di全部环i组);
    #return ;
    #---填充  ----------------------------------------
    for i面索,mp全部 in enumerate(id.polygons):
        b线选=False;i边数=len(mp全部.loop_indices);
        for i步3 in range(i边数): #如果是四边面 len等于4 如果是三角面len等于3，
            #i步=None;i步=None;i步=None;i步=None;
            i步3下步 = (i步3+1) %i边数;#3%4=3  ; 4%3=1;4%4=0
            i点索 = mp全部.vertices[i步3];#Vertex indices 如果是四边面 len等于4 如果是三角面len等于3
            #i点索下 = mp全部.vertices[i步3下步];
            i环=mp全部.loop_indices[i步3];
            i环下=mp全部.loop_indices[i步3下步];
            b选muvl一 = False;b选muvl二=False ;
            b选muvl一= Lmuvl[i环].select; #mp全部.loop_indices[i步3] 为MeshUVLoop的索引         
            b选muvl二= Lmuvl[i环下].select;
            
            if(bpy.context.window_manager.bp传播wm or b三角面G==True):
                i组转=Di全部环i组[i环];    
                i组下转=Di全部环i组[i环下];       
                    
                if(i组转 not in Di全部组LLi面索_Li环):  
                    Di全部组LLi面索_Li环[i组转]=[[],[]];#{i组转:[[i面索,i面索],[i环,i环]],}
                if(i面索 not in Di全部组LLi面索_Li环[i组转][0]):
                    Di全部组LLi面索_Li环[i组转][0].append(i面索);
                    ##print("G",i组转,"F",i面索);
                if(mp全部.loop_indices[i步3] not in Di全部组LLi面索_Li环[i组转][1]):
                    Di全部组LLi面索_Li环[i组转][1].append(mp全部.loop_indices[i步3]);                       
                
            else:
                if (b选muvl一):# 如果一点被选中
                    i组转=Di全部环i组[i环];  
                                      
                    if(i组转 not in Di全部组LLi面索_Li环):  
                        Di全部组LLi面索_Li环[i组转]=[[],[]];#{i组转:[[i面索,i面索],[i环,i环]],}           
                    if(i面索 not in Di全部组LLi面索_Li环[i组转][0]):
                        Di全部组LLi面索_Li环[i组转][0].append(i面索);
                    #if(i面索 not in Di全部组LLi面索_Li环[i组下转][0]):
                        #Di全部组LLi面索_Li环[i组下转][0].append(i面索);
                        ##print("G",i组转,"F",i面索);
                    if(i环 not in Di全部组LLi面索_Li环[i组转][1]):
                        Di全部组LLi面索_Li环[i组转][1].append(i环);       
                """
                if (b选muvl一 and b选muvl二):# 如果一条线两点被选中
                    i组转=Di全部环i组[i环];    
                    i组下转=Di全部环i组[i环下];
                
                    if(i组转 not in Di全部组LLi面索_Li环):  
                        Di全部组LLi面索_Li环[i组转]=[[],[]];#{i组转:[[i面索,i面索],[i环,i环]],}
                    if(i组下转 not in Di全部组LLi面索_Li环):  
                        Di全部组LLi面索_Li环[i组下转]=[[],[]];#{i组转:[[i面索,i面索],[i环,i环]],}             
                    if(i面索 not in Di全部组LLi面索_Li环[i组转][0]):
                        Di全部组LLi面索_Li环[i组转][0].append(i面索);
                    #if(i面索 not in Di全部组LLi面索_Li环[i组下转][0]):
                        #Di全部组LLi面索_Li环[i组下转][0].append(i面索);
                        ##print("G",i组转,"F",i面索);
                    if(i环 not in Di全部组LLi面索_Li环[i组转][1]):
                        Di全部组LLi面索_Li环[i组转][1].append(i环);       
                    if(i环下 not in Di全部组LLi面索_Li环[i组下转][1]):
                        Di全部组LLi面索_Li环[i组下转][1].append(i环下); 
                """
          
            if (b选muvl一 and b选muvl二):# 如果一条线两点被选中
                i组下转=Di全部环i组[i环下];  
                b线选=True;
                if(i组转 not in Di组此Li组左右选):#{i组此:[i组左,i组右],}
                   Di组此Li组左右选[i组转]=[];
                if(i组下转 not in Di组此Li组左右选):
                   Di组此Li组左右选[i组下转]=[];      
                if(i组转 not in Di组此Li组左右选[i组下转]):
                   Di组此Li组左右选[i组下转].append(i组转);
                if(i组下转 not in Di组此Li组左右选[i组转]):
                   Di组此Li组左右选[i组转].append(i组下转); 

                    #{ i组转:[ [i环,i环],[i面索,i面索] ],i组转:[[i环,i环],] }

    #---找出第一层的前两个组-------------------------------------------------------------------       
    ##print("D  LR==",Di组此Li组左右选);
    ##print("D all G,LLiFiR==",Di全部组LLi面索_Li环);
    i组随机=None;b闭合=True;L顺层LLi同位置环_i组_i点索序.append([]);#第一层   
    for i组此, Li组左右 in Di组此Li组左右选.items():#返回 键与值的列表 
        i组随机=i组此;
        if (len(Li组左右)==1):#此点没有左右两点  {i组此:[i组左]}  
            Li同位置环1=Di全部组LLi面索_Li环[i组此][1];
            ##print("Li1=",Li同位置环1);
            L顺层LLi同位置环_i组_i点索序[0].append([  Li同位置环1,i组此,Di全部环i点索[Li同位置环1[0]] ]); #其中一个终组  [[i组此,i面索]]
            Li同位置环2=Di全部组LLi面索_Li环[Li组左右[0]][1];
            L顺层LLi同位置环_i组_i点索序[0].append([  Li同位置环2  ,Li组左右[0], Di全部环i点索[Li同位置环2[0]]]);# [[i组此,i面索],[i组左,i面索]]  添加第二个组
            b闭合=False;
            break;   
 
    if(b闭合==True):
        Li同位置环1=Di全部组LLi面索_Li环[i组随机][1];Li组左右=Di组此Li组左右选[i组随机];
        Li同位置环2=Di全部组LLi面索_Li环[Li组左右[0]][1];
        L顺层LLi同位置环_i组_i点索序[0].append([  Li同位置环1,i组随机,Di全部环i点索[Li同位置环1[0]] ]) #头一个点      
        L顺层LLi同位置环_i组_i点索序[0].append([  Li同位置环2  ,Li组左右[0], Di全部环i点索[Li同位置环2[0]]])#第二个点       
    ##print("DigroupLR==",Di组此Li组左右选);
    ##print("DiAllGroup Face_Ring==",Di全部组LLi面索_Li环);
    print("0LayRingGroup",len(L顺层LLi同位置环_i组_i点索序[0]),L顺层LLi同位置环_i组_i点索序[0]);
    #return (ii层数G,L层Di全部选点索Li环);
    

#----------------------------------------------------------------------------
def LLLiΔΔΔ选中点排列():
    bpy.ops.object.mode_set(mode='OBJECT');
    id = bpy.context.active_object.data ;
    if (not  id.uv_layers.active):
        return {'FINISHED'};
    Lmuvl = id.uv_layers.active.data ;#UVLoopLayers.MeshUVLoopLayer.LMeshUVLoop
    L层Di选点索此Li点索左右=[];L层Di全部选点索Li环=[];Li所有三角面组=[];
    Di全部环i组={};Di全部环i点索={};Di全部组LLi面索_Li环={};Di组此Li组左右选={};
    L顺层LLi同位置环_i组_i点索序=[];#[[[i环,i环],i组转],[[i环,i环i,环,i环],i组转]]
    Li已经查找的面索=[];Li圆心环=[];
    b闭=None;b全闭=None ;
    global ii层数G;ii层数G=0;
    global i圆心组G;i圆心组G=None;
    global b三角面G;b三角面G=False;
    ΔΔ找到连贯线选(id,Lmuvl,L顺层LLi同位置环_i组_i点索序,Li所有三角面组,Di组此Li组左右选,Di全部环i组,Di全部环i点索,Di全部组LLi面索_Li环);
    #ΔΔ判断是否封闭(ii层数G,L顺层LLi同位置环_i组_i点索序,Di组此Li组左右选,L层Di全部选点索Li环);
    #return (Lmuvl,L顺层LLi同位置环_i组_i点索序,Li圆心环);
    #---排列第一层的组-L顺层LLi同位置环_i组_i点索序[0]-----------------------------------------------
    if (len(L顺层LLi同位置环_i组_i点索序[0])>1):#如果  选了两个组以上
        i计数 = len(Di组此Li组左右选);
        #print ("iCount",i计数)
        b连续 = True ;i第一个组=None;
        while (b连续==True  and 0 < i计数):            
            Li组左右 = Di组此Li组左右选[L顺层LLi同位置环_i组_i点索序[0][-1][1]];#刚开始Li组左右是第二个点的组左右，即第一点与第三点
            ##print ("Li组左右",Li组左右)
            ##print("L顺层LLi同位置环_i组_i点索序[-1]", L顺层LLi同位置环_i组_i点索序[-1])
            for i, i组左右 in enumerate( Li组左右): #刚开始  i组左右是第一个点 或 第三点              
                if ( i组左右 == L顺层LLi同位置环_i组_i点索序[0][-2][1]):#如果  i组左右  是  此点的前一个点# 刚开始是第一个点
                    if(i计数 == len(Di组此Li组左右选)):
                        i第一个组=i组左右;
                        #print("FirstG==",i第一个组);
                    ##print ("i组左右 == L顺层LLi同位置环_i组_i点索序[-2]",i组左右, L顺层LLi同位置环_i组_i点索序[-2])
 
                    if(len(Li组左右)>1 and Li组左右[i-1]==i第一个组 and i计数<len(Di组此Li组左右选)):#密封圆  最后一组为第一组
                        #print("LastGroup",);
                        i组左右 = Li组左右[i-1];
                        b连续= False;
                        break;
                        
                    elif (len(Li组左右)>1): #如果  这点连带两个点或以上# 连续选边
                        ##print ("1 < len(Li组左右)")
                        #else:
                            i组左右= Li组左右[i-1];#把此点后一个点  作为 i组左右#刚开始是第三个点
                            ##print ("Li组左右",Li组左右)
                            ##print ("L顺层LLi同位置环_i组_i点索序=",L顺层LLi同位置环_i组_i点索序)  
                    else:#此点 连带 一个点
                        i组左右 = None;
                        b连续= False;
                        ##print ("i组左右 = None")
                    break;
            i计数 -= 1;
            #----------------------------------------------------------------------------
            if (i组左右 !=None ):#如果点索为0 可能被认为False
                Li同位置环=Di全部组LLi面索_Li环[i组左右][1];
                L顺层LLi同位置环_i组_i点索序[0].append([ Li同位置环 ,i组左右,Di全部环i点索[Li同位置环[0]]]);
                ##print ("Li组左右=",Li组左右,"Li点索从头到尾选前=",L顺层LLi同位置环_i组_i点索序,"i组头=",i组头)
                ##print ("i点索比较append",i组左右)
                #b连续= True;
                
    #print("01LayRingGroupIndex",len(L顺层LLi同位置环_i组_i点索序[0]),L顺层LLi同位置环_i组_i点索序[0]);
    if(bpy.context.window_manager.bp传播wm):
        ΔΔ找到平行线(id,Lmuvl,L顺层LLi同位置环_i组_i点索序,Li已经查找的面索,Di全部环i组,Di全部环i点索,Di全部组LLi面索_Li环);

    
    if(i圆心组G):
        Li圆心环=Di全部组LLi面索_Li环[i圆心组G][1];
    #print("LiHartRing==",Li圆心环,"iHart",i圆心组G,ii层数G);
    return (Lmuvl,L顺层LLi同位置环_i组_i点索序,Li圆心环);
    
#———————————————————————————————————————————————————————
def ΔΔ找到平行线(id,Lmuvl,L顺层LLi同位置环_i组_i点索序,Li已经查找的面索,Di全部环i组,Di全部环i点索,Di全部组LLi面索_Li环):
    b平行=True;b两共面=False;b最后一层=False;b最后一点=False;b没有找圆心=False;Li三角面组=[];
    global ii层数G;global i圆心组G;
    #----根据这层组找出下一层组-----------------------------------------------------------------
    #print("LAYER------------",ii层数G);
    for i序,Li同位置环_i组序 in  enumerate(L顺层LLi同位置环_i组_i点索序[ii层数G]):#迭代下一层的各个组
        ##print("GROUP",i序);
        #if(i序==len(L顺层LLi同位置环_i组_i点索序[ii层数G])-1):#如果是最后一组
            #continue;
        ##print("Order==",i序);      
        #---找到共面索------------------------------------------------------------
        i组=Li同位置环_i组序[1];  
        if(i序==len(L顺层LLi同位置环_i组_i点索序[ii层数G])-1):#如果是最后一组        
            i组下=L顺层LLi同位置环_i组_i点索序[ii层数G][i序-1][1];#把倒数第二组为组下
            ##print("LastShareFace ,Layer ,Len,Gpre",Li共面索,ii层数G,len(L顺层LLi同位置环_i组_i点索序[ii层数G]),i组下);
            if(b最后一层==True):
                b最后一点=True;
                #print("IS LastLay&Order",i序);
                
        elif(not b最后一层):
            i组下=L顺层LLi同位置环_i组_i点索序[ii层数G][i序+1][1];
            
            Li共面索=[i面索 for i面索 in Di全部组LLi面索_Li环[ i组 ][0] if ( i面索 in Di全部组LLi面索_Li环[i组下][0] and  i面索 not in Li已经查找的面索)];#前后两组的共面索
            #Li共面索pre=Li共面索.copy();
            if(ii层数G!=0 and len(Di全部组LLi面索_Li环[i组][0])==1 and len(Di全部组LLi面索_Li环[i组下][0])<3):#最后一层最大共面索少于3
                b最后一层=True;            
                #print("IS LastLayer",);
            #print("G,Face ",i组,Di全部组LLi面索_Li环[ i组 ][0] )
            #print("G,FaceNext ",i组下,Di全部组LLi面索_Li环[i组下][0])

            #print("FaceRecorded ",Li已经查找的面索);
            #print("ShareFace---",Li共面索);
            
            ##print("GROUP",L顺层LLi同位置环_i组_i点索序[ii层数G][i序][1]);
        if(b最后一层==True and not b最后一点):#最后一层
            
            i组下=L顺层LLi同位置环_i组_i点索序[ii层数G][i序+1][1];
            Li共面索=[i面索 for i面索 in Di全部组LLi面索_Li环[ i组 ][0] if ( i面索 in Di全部组LLi面索_Li环[i组下][0] )];
            if(not Li共面索 or  len(Li共面索)>1):
                """
                if(not Li共面索 ):
                    print("NOT_SHARE_FACE2",);
                else:
                    print("SHARE_FACE >1",);
                """
                b两共面=True ;b平行=False ;  
            """
            print("G,FaceE ",i组,Di全部组LLi面索_Li环[ i组 ][0] )
            print("G,FaceNextE ",i组下,Di全部组LLi面索_Li环[i组下][0])
            print("ShareFaceE---",Li共面索);
            """
        if(not Li共面索 or  len(Li共面索)>1):
            """
            if(not Li共面索 ):
                print("NOT_SHARE_FACE",);
            else:
                print("SHARE_FACE >1",);
            print("NO BALLANCE",);
            """
            b两共面=True ;b平行=False ;break;  
        #----------------------------------------------------------------------------
        try:
            L顺层LLi同位置环_i组_i点索序[ii层数G+1];
        except:
            L顺层LLi同位置环_i组_i点索序.append([]);#增加一层    
        if(Li共面索[0] not in Li已经查找的面索):
            Li已经查找的面索.append(Li共面索[0]); 
            
        mp两组共面=id.polygons[Li共面索[0]];
        B=False;
        if(len(mp两组共面.loop_indices)!=4 and len(mp两组共面.loop_indices)==3):
            for i步3,i环 in enumerate(mp两组共面.loop_indices):
                Li三角面组.append(Di全部环i组[i环]);
            #print("NOT QUAT",);#当遇到三角面时 最后一层为空[]
            b平行=False;break;
            
        for i步3 in range(len(mp两组共面.loop_indices)):#找到并排列下一层组
              
            i步3下步 = (i步3+1) % len(mp两组共面.loop_indices);#3%4=3  ; 4%3=1;4%4=0
            i组转=Di全部环i组[mp两组共面.loop_indices[i步3]];
            i组下转=Di全部环i组[mp两组共面.loop_indices[i步3下步]];
            """"""
            #-----如果是最后第一组------------------------------------------------------------
            if(i序==len(L顺层LLi同位置环_i组_i点索序[ii层数G])-1):
                #print("While Last   Group,GroupNext==",i组,i组下);
                if(i组==i组转 and i组下!=i组下转):#顺→
                    #print("exeLast",);
                    L顺层LLi同位置环_i组_i点索序[ii层数G+1].append([Di全部组LLi面索_Li环[i组下转][1],i组下转]);B=True;break;#
                elif(i组==i组下转 and i组下!=i组转):#逆←
                    #print("exeLast",);
                    L顺层LLi同位置环_i组_i点索序[ii层数G+1].append([Di全部组LLi面索_Li环[i组转][1],i组转]);B=True; break;#
              
            #----正常的组-------------------------------------------------------------
            if(i组==i组转 and i组下!=i组下转):#顺→
                L顺层LLi同位置环_i组_i点索序[ii层数G+1].append([Di全部组LLi面索_Li环[i组下转][1],i组下转]);B=True;break;
            elif(i组==i组下转 and i组下!=i组转):#逆←
                L顺层LLi同位置环_i组_i点索序[ii层数G+1].append([Di全部组LLi面索_Li环[i组转][1],i组转]);B=True;break;


        #if(not B):
            #print("NO NO NO NO,Order==,",i序);
    #------找圆心-------------------------------------------------------------
    if(b没有找圆心==False):
        i组1=L顺层LLi同位置环_i组_i点索序[ii层数G][0][1];i组2=L顺层LLi同位置环_i组_i点索序[ii层数G][1][1];#这是未ii层数+1时添加的组
        Li圆心=[i for i in Li三角面组 if(i!=i组1 and i!=i组2)];
        if(Li圆心):
            i圆心组G=Li圆心[0];
        b没有找圆心=True;
        ##print("HartGroup==",i圆心组G);
        ##print("Group1==",i组1,"Group2==",i组2);
    ##print("Glen,Llen,Layer",len(L顺层LLi同位置环_i组_i点索序[ii层数G]),L顺层LLi同位置环_i组_i点索序,ii层数G);
    if(b平行==True and b两共面==False and b最后一层==False and b最后一点==False):
        ii层数G+=1;
        ΔΔ找到平行线(id,Lmuvl,L顺层LLi同位置环_i组_i点索序,Li已经查找的面索,Di全部环i组,Di全部环i点索,Di全部组LLi面索_Li环);


#----------------------------------------------------------------------------
            
def ΔΔ赋值线uv(Lmuvl,ii选点总数,ii层数,L顺层LLi同位置环_i组_i点索序,Lcf2UV应真序,Lcf2UV平行线应真序):

    b全封闭=False;
    if (L顺层LLi同位置环_i组_i点索序[0][0][1]==L顺层LLi同位置环_i组_i点索序[0][-1][1]): #全封闭 
        b全封闭=True;#print("ALL CLOSE",);
        
    if(b全封闭 ):#这种情况不能运行否则会出错
        return ;
    #ii选点总数=len(L顺层LLi同位置环_i组_i点索序);ii层数=len(L顺层LLi同位置环_i组_i点索序);
    #-----赋值给第一层uv---------------------------------------------------------------
    for i序, LLi同位置环_i组_i点索序 in enumerate(L顺层LLi同位置环_i组_i点索序[0]):#先排列第一层
        uv此点真=Vector((Lcf2UV应真序[i序][0],Lcf2UV应真序[i序][1]))#此点索的uv
        for i环步 in range(  len(LLi同位置环_i组_i点索序[0]) ):#迭代  此点所有  环             
            Lmuvl[ LLi同位置环_i组_i点索序[0][i环步] ].uv=uv此点真;

    #-----赋值给平行层uv------------------------------------------------------------
    #for i层,LLi同位置环_i组_i点索序 in enumerate(L顺层LLi同位置环_i组_i点索序):
        #print("Lay, LiR,G,IP==",i层,LLi同位置环_i组_i点索序);
        
    i总层数=ii层数-3;
    #print("LayerCount==",ii层数,i总层数);
    if((not bpy.context.window_manager.bp传播wm or i总层数<1) or b三角面G==True):
        cf2最后一层第一个组位=(c_float*2)(0,0);
    elif(L顺层LLi同位置环_i组_i点索序[-1]==[]):
        cf2最后一层第一个组位=cf2ΔΔ转uv为cf2(Lmuvl[ L顺层LLi同位置环_i组_i点索序[-2][0][0][0] ].uv);#最后一层第一个组位
        i总层数=ii层数-2;
    else:
        cf2最后一层第一个组位=cf2ΔΔ转uv为cf2(Lmuvl[ L顺层LLi同位置环_i组_i点索序[-1][0][0][0] ].uv);#最后一层第一个组位
    for i层,LLi同位置环_i组_i点索序 in enumerate(L顺层LLi同位置环_i组_i点索序):
        #print("Lay, LiR,G,IP==",i层,LLi同位置环_i组_i点索序);
        if((not bpy.context.window_manager.bp传播wm or ii层数<4) and i层==0):#如果只有两层
            break;
        if(i层==0 or i层==ii层数-1):#从第二层算起作第一层 倒数一层不用算，因为走最后一层时记录了倒数第二层，走倒数第二层时记录了最后一层
            continue;
        
        D.DLL.ΔΔ传播平行点(ii选点总数,i总层数,i层,Lcf2UV应真序,cf2最后一层第一个组位,Lcf2UV平行线应真序);
        #return ;
        for i序, Li同位置环_i组序 in enumerate(LLi同位置环_i组_i点索序):#先排列第一层
            uv此点真=Vector((Lcf2UV平行线应真序[i序][0],Lcf2UV平行线应真序[i序][1]));#此点索的uv
            for i环步 in range(  len(Li同位置环_i组序[0]) ):#迭代  此点所有  环             
                Lmuvl[ Li同位置环_i组序[0][i环步] ].uv=uv此点真;
        
   

#=================================================================
class 卐UV圆滑卐Operator (bpy.types.Operator):
    bl_idname = 'uv.circle'
    bl_label = 'circle '
    bl_options = {'REGISTER', 'UNDO'}
    bl_description = "arrange the uv in a precise circle"
    
    @classmethod
    def poll(cls, context):
        obj = context.active_object;
        if (obj and obj.type == 'MESH') :
            id=obj.data;
            if not  id.uv_layers.active:
                return False ;
        return (obj and obj.type == 'MESH');
        
    def execute(self, context):
        if(context.scene.tool_settings.use_uv_select_sync== True):
            context.scene.tool_settings.use_uv_select_sync= False;return {'FINISHED'};
        ##print ("卐UV圆滑卐Operator")
        #LLLiΔΔΔ选中点排列();bpy.ops.object.mode_set(mode='EDIT');return {'FINISHED'}
        Lmuvl,L顺层LLi同位置环_i组_i点索序,Li圆心环=LLLiΔΔΔ选中点排列();
        
        #for i, LLi同位置环_i组_i点索序 in enumerate(L顺层LLi同位置环_i组_i点索序):
            ##print("LayRingGroup",len(L顺层LLi同位置环_i组_i点索序),len(LLi同位置环_i组_i点索序),LLi同位置环_i组_i点索序);
        #return {'FINISHED'};#■■
        b全封闭=False;
        if (L顺层LLi同位置环_i组_i点索序[0][0][1]==L顺层LLi同位置环_i组_i点索序[0][-1][1]): #全封闭
            uv头=Lmuvl[ L顺层LLi同位置环_i组_i点索序[0][0][0][0] ].uv;#[i点索,[i环选0,-1,i环选2,-1]]
            uv尾=Lmuvl[ L顺层LLi同位置环_i组_i点索序[0][1][0][0] ].uv;  
            b全封闭=True;#print("ALL CLOSE",);
        else: #正常点
            ##print("i face==",i个面共点);
            uv头=Lmuvl[ L顺层LLi同位置环_i组_i点索序[0][0][0][0] ].uv;#[i点索,[i环选0,i环选2,]]		
            uv尾=Lmuvl[ L顺层LLi同位置环_i组_i点索序[0][-1][0][0] ].uv;
        
        uv中=Lmuvl[L顺层LLi同位置环_i组_i点索序[0][len(L顺层LLi同位置环_i组_i点索序[0])//2][0][0]].uv;
        
        cf2头=cf2ΔΔ转uv为cf2(uv头);cf2尾=cf2ΔΔ转uv为cf2(uv尾);cf2中=cf2ΔΔ转uv为cf2(uv中);
        cf3XYR=(c_float*3)();
        #D.DLL.bΔΔ求圆心与半径坐标给f3四 .argtypes = [c_float, c_float,c_float,c_float] # 参数类型，两个float（c_float内ctypes类型） 
        D.DLL.bΔΔ求圆心与半径坐标给f3四.restype = c_bool;
        b有圆心=D.DLL.bΔΔ求圆心与半径坐标给f3四(cf2头,cf2尾,cf2中,cf3XYR);
        #print("HAEV HART==",b有圆心);
        if(b有圆心==False ):
            ##print ("圆心成一直线",b有圆心)
            卐UV平滑卐Operator.execute(self, context);
            bpy.ops.object.mode_set(mode='EDIT');
            return {'FINISHED'};
        ##print ("有圆心",b有圆心)
        #uv圆心=Vector((cf3XYR[0],cf3XYR[1]));
        f半径=cf3XYR[2]; 
        cf2圆心=(c_float*2)(cf3XYR[0],cf3XYR[1]);
        #print("HART==",cf3XYR[0],cf3XYR[1]);#正确
        
        D.DLL.fΔΔ知三点求对角弧.restype = c_float ;D.DLL.bΔΔ检测总弧是否顺时针.restype = c_bool;
        b顺=D.DLL.bΔΔ检测总弧是否顺时针(cf2头,cf2中, cf2尾, cf2圆心);
        #print("bORDER==", b顺);
        
        f对角弧=D.DLL.fΔΔ知三点求对角弧(cf2头,cf2尾,cf2圆心);
        f中弧=D.DLL.fΔΔ知三点求对角弧(cf2头,cf2尾,cf2中);
        if(f中弧<pi/2):#这是大于半圆的弧
            f对角弧=2*pi-f对角弧;#取反弧度

        if(b全封闭==True):#全封闭
            f对角弧=-2*pi;
            #f平均弧=f对角弧/(len(L顺层LLi同位置环_i组_i点索序[0])-1);
            
        #else:
        f平均弧=f对角弧/(len(L顺层LLi同位置环_i组_i点索序[0])-1);
            
        #print ("fHU==",f对角弧,f中弧);    
        #----赋值uv------------------------------------------------------------------     
        if(b全封闭==True and context.window_manager.bp传播wm):
            for i in range( len(Li圆心环)):#迭代  此点所有uv loop 赋值圆心
                Lmuvl[Li圆心环[i]].uv=Vector((cf2圆心[0],cf2圆心[1]));
            
        ii层数=len(L顺层LLi同位置环_i组_i点索序);
        uv半径矢量=uv头-Vector((cf2圆心[0],cf2圆心[1]));
        if(not context.window_manager.bp传播wm):
            f每段比例=f每段半径=0;
        else:
            f每段半径=f半径/(ii层数-1);
            f每段比例=f每段半径/uv半径矢量.length;

        for i层,LLi同位置环_i组_i点索序 in enumerate(L顺层LLi同位置环_i组_i点索序) :
            if(b全封闭==False and i层>0):
                break;
            if(not context.window_manager.bp传播wm and i层>0):
                break;
            ##print("APPLY  Layer,LL==",i层,LLi同位置环_i组_i点索序);
            if(ii层数>1 and i层==ii层数-1):#从第二层算起作第一层 倒数一层不用算，因为走最后一层时记录了倒数第二层
                continue;
            for i序, Li同位置环_i组_i点索序 in enumerate(LLi同位置环_i组_i点索序):
                if (b全封闭==True and (i序==0 or i序==len(L顺层LLi同位置环_i组_i点索序[0])-1)): #如果是头或尾点 并封闭
                    uv头真=uv半径矢量-uv半径矢量*f每段比例*i层+Vector((cf2圆心[0],cf2圆心[1]));
                    for i in range( len(Li同位置环_i组_i点索序[0])):#迭代  此点所有uv loop
                        Lmuvl[Li同位置环_i组_i点索序[0][i]].uv=Vector((uv头真[0],uv头真[1]));    
                    continue;
                if(b全封闭==False and (i序==0 or i序==len(L顺层LLi同位置环_i组_i点索序[0])-1)):#如果 只是线选
                    continue;
                ##print ("i点索序选",Li同位置环_i组_i点索序)
                cf加弧正=c_float(f平均弧*i序);

                D.DLL.fΔΔ求加弧正真.restype = c_float ;
                f加弧正真=D.DLL.fΔΔ求加弧正真(cf2头,cf2圆心, cf加弧正,b顺  );
                
                cf2圆此点真=(c_float*2)();
                cf加弧正真=c_float(f加弧正真);cf半径=c_float(f半径-(f每段半径*i层));
                D.DLL.ΔΔ知弧求点给f2四真(cf加弧正真,cf半径, cf2圆心,cf2圆此点真);

                for i in range( len(Li同位置环_i组_i点索序[0])):#迭代  此点所有uv loop
                    Lmuvl[Li同位置环_i组_i点索序[0][i]].uv=Vector((cf2圆此点真[0],cf2圆此点真[1]));
                
        bpy.ops.object.mode_set(mode='EDIT');
        return {'FINISHED'};

#---------------------------------------------------------------------------------------  
global f距离参数G;f距离参数G=None;

class 卐UV平滑卐Operator (bpy.types.Operator):
    bl_idname = 'uv.smooth'
    bl_label = 'smooth'
    bl_options = {'REGISTER', 'UNDO'}
    bl_description = "smooth uv while preserving the shape"
    
    cf距离参数=None;
    @classmethod
    def poll(cls, context):
        obj = context.active_object;
        if (obj and obj.type == 'MESH'):
            id=obj.data;
            if (not  id.uv_layers.active):
                return False ;
        return (obj and obj.type == 'MESH');
    def execute(self, context):
        if(context.scene.tool_settings.use_uv_select_sync== True):
            context.scene.tool_settings.use_uv_select_sync= False;return {'FINISHED'};
        global f距离参数G;
        #print("G==",f距离参数G);
        self.cf距离参数=f距离参数G;
        if(self.cf距离参数==None):
            #print("G==None",self.cf距离参数);
            self.cf距离参数=c_float(bpy.context.scene.fp参数s2);
        Lmuvl,L顺层LLi同位置环_i组_i点索序,Li圆心环=LLLiΔΔΔ选中点排列();
        ii层数=len(L顺层LLi同位置环_i组_i点索序);
        ii选点总数=len(L顺层LLi同位置环_i组_i点索序[0]);
        
        Lcf2uv选序=((c_float*2)*ii选点总数)();Lcf2UV应真序=((c_float*2)*ii选点总数)();Lcf2UV平行线应真序=((c_float*2)*ii选点总数)();

        for i序, Li同位置环_i组_i点索序 in enumerate(L顺层LLi同位置环_i组_i点索序[0]):#第一层
            uv=Lmuvl[Li同位置环_i组_i点索序[0][0]].uv;
            ##print("uv loop==",LLi同位置环_i组_i点索序[0],LLi同位置环_i组_i点索序[0][0]);
            #Luv序.append(uv)
            cf2UV=cf2ΔΔ转uv为cf2(uv);
            Lcf2uv选序[i序]=cf2UV;

        ##print ("Luv序",Luv序,"i个面共点",i个面共点)
        Lcf每段长正=(c_float*ii选点总数)();Lcf每段累长正=(c_float*ii选点总数)();

        Lcf网每段累长正=(c_float*ii选点总数)();
        ##print ("Lmuvl一",Lmuvl)#为什么Lmuvl为有
        Lcf3网点有序co=Lcf3ΔΔ得选点网co列表(ii选点总数,L顺层LLi同位置环_i组_i点索序);#这个把Lmuvl弄没了
        #Lcf3网点有序co=((c_float*3)*ii选点总数)();
        #for i in Lcf3网点有序co: #print ("iCO==",i[0],i[1],i[2]);#co坐标
        #for i in Lcf2uv选序: #print ("fuv==",i[0],i[1]);#uv坐标
        ##print ("iiPoint==",ii选点总数)
        D.DLL.ΔΔUV平滑给Lf2八(ii选点总数,self.cf距离参数,Lcf网每段累长正,Lcf3网点有序co,Lcf每段长正,Lcf每段累长正,Lcf2uv选序, Lcf2UV应真序); 
                                                         
        #--赋值给uv------------------------------------------------------------------

        ΔΔ赋值线uv(Lmuvl,ii选点总数,ii层数,L顺层LLi同位置环_i组_i点索序,Lcf2UV应真序,Lcf2UV平行线应真序);

        bpy.ops.object.mode_set(mode='EDIT');
        f距离参数G=None;
        return {'FINISHED'};
        
#——————————————————————————————————————————————————————       
class 卐UV三倍平滑卐Operator (bpy.types.Operator):
    bl_idname = 'uv.smooth3'
    bl_label = 'smooth'
    bl_options = {'REGISTER', 'UNDO'}
    bl_description = "smooth uv heavier"
    
    @classmethod
    def poll(cls, context):
        obj = context.active_object
        if (obj and obj.type == 'MESH'):
            id=obj.data
            if not  id.uv_layers.active:
                return False 
        return (obj and obj.type == 'MESH')
        
    def execute(self, context):
        global f距离参数G;
        for cf距离参数 in [c_float(0.0),c_float(1.0),c_float(0.5),c_float(bpy.context.scene.fp参数s2)]:
            #卐UV平滑=卐UV平滑卐Operator("OPERATOR");
            #卐UV平滑.cf距离参数=cf距离参数;
            
            f距离参数G=cf距离参数;
            #卐UV平滑卐Operator.execute(self, context);
            bpy.ops.uv.smooth('INVOKE_DEFAULT',);
        return {'FINISHED'};
        
#-------------------------------------------------------------------------------------
class 卐拉直卐Operator (bpy.types.Operator):
    '''拉直'''
    bl_idname = 'straight.uv'
    bl_label = 'straight'
    bl_options = {'REGISTER', 'UNDO'}
    bl_description = "straithen uv and homogeneous alignment  "
    
    @classmethod
    def poll(cls, context):
        obj = context.active_object
        if (obj and obj.type == 'MESH'):
            id=obj.data
            if not  id.uv_layers.active:
                return False 
        return (obj and obj.type == 'MESH')
    def execute(self, context):
        if(context.scene.tool_settings.use_uv_select_sync== True):
            context.scene.tool_settings.use_uv_select_sync= False;return {'FINISHED'};
        Lmuvl,L顺层LLi同位置环_i组_i点索序,Li圆心环=LLLiΔΔΔ选中点排列();
        #return {'FINISHED'}
        ii选点总数=len(L顺层LLi同位置环_i组_i点索序[0]);
        ii层数=len(L顺层LLi同位置环_i组_i点索序);
        
        uv头=Lmuvl[L顺层LLi同位置环_i组_i点索序[0][0][0][0]].uv;	#[i点索,[i环选0,i环选2,]]		
        uv尾=Lmuvl[L顺层LLi同位置环_i组_i点索序[0][-1][0][0]].uv;
      
        cf2UV头=cf2ΔΔ转uv为cf2(uv头);cf2UV尾=cf2ΔΔ转uv为cf2(uv尾);
        Lcf2UV应真序=((c_float*2)*ii选点总数)();Lcf2UV平行线应真序=((c_float*2)*ii选点总数)();
        D.DLL.ΔΔ拉直UV给Lf2四(ii选点总数,cf2UV头,cf2UV尾,Lcf2UV应真序);  
  
        ΔΔ赋值线uv(Lmuvl,ii选点总数,ii层数,L顺层LLi同位置环_i组_i点索序,Lcf2UV应真序,Lcf2UV平行线应真序);
        bpy.ops.object.mode_set(mode='EDIT');
        return {'FINISHED'}


#-------------------------------------------------------------------------------------     
class 卐自动对齐卐Operator (bpy.types.Operator):
    bl_idname = 'align.uv'
    bl_label = 'align'
    bl_options = {'REGISTER', 'UNDO'}
    bl_description = "align uv in X or Y axis and homogeneous alignment  "

    @classmethod
    def poll(cls, context):
        obj = context.active_object
        if (obj and obj.type == 'MESH'):
            id=obj.data
            if not  id.uv_layers.active:
                return False 
        return (obj and obj.type == 'MESH')
    def execute(self, context):   
        if(context.scene.tool_settings.use_uv_select_sync== True):
            context.scene.tool_settings.use_uv_select_sync= False;return {'FINISHED'};    
        Lmuvl,L顺层LLi同位置环_i组_i点索序,Li圆心环=LLLiΔΔΔ选中点排列();
        ii层数=len(L顺层LLi同位置环_i组_i点索序);
        ii选点总数=len(L顺层LLi同位置环_i组_i点索序[0]);
        
        uv头=Lmuvl[L顺层LLi同位置环_i组_i点索序[0][0][0][0]].uv;	#[i点索,[i环选0,i环选2,]]		
        uv尾=Lmuvl[L顺层LLi同位置环_i组_i点索序[0][-1][0][0]].uv;
        #print("Head Tail==",uv头,uv尾);
        cf2UV头=cf2ΔΔ转uv为cf2(uv头);cf2UV尾=cf2ΔΔ转uv为cf2(uv尾);
        Lcf2UV应真序=((c_float*2)*ii选点总数)();Lcf2UV平行线应真序=((c_float*2)*ii选点总数)();
        D.DLL.ΔΔ自动对齐UV给Lf2四(ii选点总数,cf2UV头,cf2UV尾,Lcf2UV应真序)
        
        ΔΔ赋值线uv(Lmuvl,ii选点总数,ii层数,L顺层LLi同位置环_i组_i点索序,Lcf2UV应真序,Lcf2UV平行线应真序);
        
        bpy.ops.object.mode_set(mode='EDIT')
        return {'FINISHED'}            
        
#////////////////////////////////////////////////////////////////////////       
class 卐载入DLL卐Operator (bpy.types.Operator):
    bl_idname = 'loaddll.uv';
    bl_label = '载入dll';
    bl_options = {'REGISTER', 'UNDO'};
    
    @classmethod
    def poll(cls, context):      
        return True; #(obj and obj.type == 'MESH')
    def execute(self, context):
        #D=卐DLL类型();
        try:
            D.DLL = CDLL(dllpath32E);
        except:
            D.DLL = CDLL(dllpath64E);
        return {'FINISHED'};
        
class 卐删除DLL卐Operator (bpy.types.Operator):
    '''删除dll'''
    bl_idname = 'deldll.uv'
    bl_label = 'deldll'
    bl_options = {'REGISTER', 'UNDO'}
    @classmethod
    def poll(cls, context):
        obj = context.active_object          
        return (obj and obj.type == 'MESH')
    def execute(self, context):
        #if(D.DLL):
        windll.kernel32.FreeLibrary(D.DLL._handle)#释放dll     
            #bpy.utils.unregister_module(__name__)
            ##print ("已经删除DLL")
        ##print ("fp=",context.scene.fp参数s2)
        return {'FINISHED'}
#/////////////////////////////////////////////////////////////////////////
class 卐Panel(bpy.types.Panel):
    bl_space_type = 'IMAGE_EDITOR'
    bl_region_type = 'UI'
    bl_idname = '平滑uv'
    bl_label = "uv_tool"
    bl_context = "objectmode"
    #bpy.types.UVLoopLayers.fp参数uvll=FloatProperty(name="fp参数s2", description="--", default=0.0, min=0.0, max=1.0, soft_min=0.0, soft_max=1.0, step=3, precision=2)
    #bl_options = {'DEFAULT_CLOSED'}
    def draw(self, context):
        uil界 = self.layout
        uil列一= uil界.column(align=True)
        uil列二=uil列一.split(0.2)
        uil列二.operator(卐UV圆滑卐Operator.bl_idname, text="Circle",icon="SPHERECURVE")
        uil列二.operator(卐UV平滑卐Operator.bl_idname, text="Smooth",icon="SMOOTHCURVE")
        uil列二.operator(卐UV三倍平滑卐Operator.bl_idname, text="smooth*3")
        uil行=uil界.row(align=True);
        uil行.prop( context.scene, "fp参数s2", text = "mesh distance", slider = True,);
        uil行.prop( context.window_manager, "bp传播wm", text = "transmission", toggle=True);
        
        uil列二=uil界.column(align=True).split(0.5)
        uil列二.operator(卐拉直卐Operator.bl_idname, text="Straighten",icon="LINCURVE")
        uil列二.operator(卐自动对齐卐Operator.bl_idname, text="Align",icon="NOCURVE")
        uil列二=uil界.column(align=True).split(0.5)
        #uil列二.operator(卐载入DLL卐Operator.bl_idname, text="load dll")
        #uil列二.operator(卐删除DLL卐Operator.bl_idname, text="unload dll&unregister")
        

def register():
    bpy.utils.register_module(__name__)
    bpy.types.Scene.fp参数s2=FloatProperty(name="fp参数s2", description="this will effect the uv according to the mesh shape", default=0.5, min=0.0, max=1.0, soft_min=0.0, soft_max=1.0, step=3, precision=2);
    bpy.types.WindowManager.bp传播wm=BoolProperty(name="transmission", description="transmission", default=False); 
def unregister():
    bpy.ops.deldll.uv('INVOKE_DEFAULT',);
    del bpy.types.Scene.fp参数s2;
    del bpy.types.WindowManager.bp传播wm;
    bpy.utils.unregister_module(__name__);

if __name__ == "__main__":
    register()
b闭=True  
#//////////////////////////////////////////////////////////////////////


